// file: check_endian.cc
//

// this is a simple routine to check the endian-ness of a platform
// if it is big endian, a 0 is returned, else a 1 is returned
//
#include <stdio.h>

// define output constants
//
#define BIG_ENDIAN      0
#define LITTLE_ENDIAN   1

// method: little_endian
//
// arguments: none
//
// return: integer which defines whether it is little endian or big endian
//
// this method determines the endian-ness of the platform it is run on. note
// that it only works on platforms that have a 16-bit short int.
//
int little_endian() {
  short int w = 0x0001;
  char *byte = (char *) &w;
  return(byte[0] ? LITTLE_ENDIAN : BIG_ENDIAN);
}

int main () {  
  fprintf (stdout, "%d\n", little_endian());
}

